;  ⮤   ( १㧪   ⮬ ࠢ ⭮ ணࠬ)
; (c) 2017 by Jin X (jin.x@sources.ru)

; 䨪 Intel: https://www.intel.ru/content/dam/www/public/us/en/documents/datasheets/nm10-chipset-datasheet.pdf
;   : http://dims.karelia.ru/x86/initial.shtml
; RBIL: http://www.cs.cmu.edu/~ralf/files.html

RETURNMODE	=	0Ah		; ०  (. )
PRINTSTATUS	=	1		; 1 - 뢮 ﭨ ॣ஢  ⮢, 0 -  뢮 ( 祭 ⮫쪮  RETURN <> 0)

;-----------------------------------------------------------------------------------------------------------------------

		org	100h

		;-------------------------------------------------------------------------------------------------------
		;  ᪮  ( SmartDrv, DoubleSpace  )
		mov	ah,0Dh
		int	21h

		cli			; 頥 뢠
if	RETURN & PRINTSTATUS
		mov	eax,cr0		; ࠭塞 祭 CR0 (⮡ ⮬   祭)
		mov	[SavedCR0],eax
		in	al,70h		; ﭨ NMI
		mov	[P70],al
end if
		; ᫥   BIOS 㤥 ஢ 祩 CMOS  ஬ 0Fh,  ன   ᠭ    祭 0Dh..0FFh (hardware reset),
		;  0 (software reset),  0Ah (jmp dword [40h:67h]),  5 (१ ஫ 뢠 + jmp dword [40h:67h]), ... . RBIL :)
		mov	al,8Fh
		out	70h,al		; 롨ࠥ 祩  頥 NMI (訩 7-  뫠 祭 ⠭)
if	RETURN
		mov	al,RETURNMODE	; ० 
end if
		out	71h,al

if	RETURN
		; ⠢  
		xor	cx,cx
		mov	es,cx
		mov	word [es:467h],Return	; 40h:67h  ᮤঠ  
		mov	[es:467h+2],cs

		; ࠭塞 SS:SP (  砥  뫮   ࠭,    ந ᠬ  祭 CS    祭 SP,    ᤥ ⠪)
		mov	[SavedSP],sp
		mov	[SavedSS],ss

		; ࠭塞 ᪨ 뢠
		in	al,21h		; 뢠 0..7
		mov	[P21],al
		in	al,0A1h		; 뢠 8..15
		mov	[PA1],al
		; ࠭塞 ﭨ  A20 ( ⠫쭮 )
		in	al,92h
		mov	[P92],al
end if ; if RETURN
		call	RESETPROC	; 믮塞 

		xor	cx,cx
		loop	$		;  㧠 ( 直 砩)

		;  ࠡ⠫?
		; 뢮 ᮮ饭
		mov	si,MsgFail
Finish:
		xor	al,al
		out	70h,al		; ࠧ蠥 NMI
		sti			; ࠧ蠥 뢠

		cld
		mov	ah,0Eh
	.next:	lodsb
		test	al,al
		jz	.end
if	RETURN & PRINTSTATUS
		mov	cx,1		; - ७ ᨬ,  1 (  ch = 0  ⠪,   )
		jns	@F		; ᫨ ⨫    >= 80h,  ⠬ ࠭ - ७ ᫥饣 ᨬ,  룠
		and	al,not 80h	; 㤠塞 訩 
		mov	cl,al		; cx = - ७
		lodsb			; ᠬ ᨬ
end if
	@@:	int	10h		; 뢮 ᨬ
if	RETURN & PRINTSTATUS
		loop	@R		; 塞 뢮 cx ࠧ
end if
		jmp	.next
	.end:
		xor	ah,ah
		int	16h		;  

		int	20h		; 室 ( ஢ਬ -   ଠ쭮  㭪ﬨ DOS)

if used Reset1
Reset1:		;---------------------------------------------------------------------------------------------------------------
		; ***    (Intel) १ ॣ ࠢ ᮬ ***
		; DOS (VMWare):  ࠡ⠥ ( ० ,  ० १㧪)
		; DOSBox:  ࠡ뢠 (   楤  뢮 ᮮ饭 'CPU reset is failed!')
		; Win3.11 (VMWare):  ०  稭  (  뤠 'Divide overflow',  ,    ந室),  ० १㧪 १㦠 
		; Win98 (VMWare):  ०  ᠥ (⮫쪮   ),  ० १㧪 १㦠 
		; WinNT-7 (VMWare):  ࠡ뢠 (   楤  뢮 ᮮ饭 'CPU reset is failed!')
		mov	dx,0CF9h
if	RETURN
		mov	al,0000b	;  1: 1 = hard reset, 0 = SOFT reset;  2: 믮  ;  3:   (BIST - built-in self test)  hard reset
else
		mov	al,1010b	;  1: 1 = HARD reset, 0 = soft reset;  2: 믮  ;  3:   (BIST - built-in self test)  hard reset
end if
		out	dx,al		;  뢠 ᫥  2-   0  1, ⮬ 襬 ᭠砫 0  直 砩
		or	al,0100b	; ⠭   : 13.7.5. Reset CPU (RST_CPU) - R/W. When this bit transitions from a 0 to a 1, it initiates a hard or soft reset, as determined by the SYS_RST bit (bit 1 of this register) [Intel]
		out	dx,al		; when resetting the CPU, two writes are required: the first sets the state of bit 1 while keeping bit 2 cleared, and the second sets bit 2; the reset occurs on bit 2's transition from 0 to 1 [RBIL]
		ret
end if ; if used Reset1
if used Reset2
Reset2:		;---------------------------------------------------------------------------------------------------------------
		; ***    १ ॣ 樠樨   A20 ***
		; DOS (VMWare):  ࠡ⠥ ( ० ,  ० १㧪)
		; DOSBox:  ࠡ뢠 (  뢮 ᮮ饭 'CPU reset via port 0x92 not supported'; ந室 ਩ 襭 ࠡ १ ᪮쪮 ᥪ㭤)
		; Win3.11 (VMWare):  ०  ᠥ ( VMWare 뢮 'The CPU has been disabled by the guest OS. Power off or reset the VM',   ),  ० १㧪 १㦠 
		; Win98 (VMWare):  ०  ᠥ (⮫쪮   ),  ० १㧪 १㦠 
		; WinNT-7 (VMWare):  ࠡ뢠 (   楤  뢮 ᮮ饭 'CPU reset is failed!')
		in	al,92h
		and	al,not 1
		out	92h,al		;  뢠 ᫥  0-   0  1, ⮬ 襬 ᭠砫 0  直 砩
		or	al,1		; 13.7.3. INIT_NOW - R/W. When this bit transitions from a 0 to a 1, the Chipset will force INIT# active for 16 PCI clocks [Intel]
		out	92h,al		; pulse alternate reset pin (high-speed alternate CPU reset) [RBIL]
		ret
end if ; if used Reset2
if used Reset3
Reset3:		;---------------------------------------------------------------------------------------------------------------
		; ***    १ ஫  ***
		; DOS (VMWare):  ࠡ⠥ ( ० ,  ० १㧪)
		; DOSBox:  ࠡ뢠 (   楤  뢮 ᮮ饭 'CPU reset is failed!')
		; Win3.11 (VMWare):  ०  ᠥ ( VMWare 뢮 'The CPU has been disabled by the guest OS. Power off or reset the VM',   ),  ० १㧪 १㦠 
		; Win98 (VMWare):  ࠡ뢠 (ந室 ਩ 襭 ࠡ ணࠬ १ ᪮쪮 ᥪ㭤)
		; WinNT-7 (VMWare):  ࠡ뢠 (   楤  뢮 ᮮ饭 'CPU reset is failed!')
		xor	cx,cx
	@@:	in	al,64h		; ⠥  ﭨ ஫  8042
		test	al,2		; 䫠 ⮢  ਥ 
		loopnz	@R

		mov	al,0FEh
		out	64h,al		; 뫠  
;		jmp	@R		;  砩, ᫨ ஫     ⮢
		ret
end if ; if used Reset3
if used Reset4
Reset4:		;---------------------------------------------------------------------------------------------------------------
		; ***  १㧪 १ BIOS ***
		; DOS (VMWare):  ࠡ⠥ ( ० ,  ० १㧪)
		; DOSBox: ,  ॡ १㧪 ('Reboot requested, quitting now.')  蠥 ࠡ
		; Win3.11 (VMWare):  ࠡ뢠 (ந室 ਩ 襭  ᮮ饭,  ਫ 訫 楫⭮ ⥬)
		; Win98 (VMWare):  ࠡ뢠 (ந室 ਩ 襭 ࠡ ணࠬ १ ᪮쪮 ᥪ㭤)
		; WinNT-XP (VMWare):  ࠡ뢠 (ணࠬ  蠥 ࠡ  뢮 ᮮ饭)
		; WinVista,7 (VMWare):  ࠡ뢠 (NTVDM ਩ 蠥 १ ᪮쪮 ᥪ㭤)
		jmp	0F000h:0FFF0h	; १㧪
		ret
end if ; if used Reset4
if used Reset5
Reset5:		;---------------------------------------------------------------------------------------------------------------
		; *** १㧪 १ int 19h (宩 ⮤,   ᯮ짮 !!!) ***
		; DOS (VMWare): १㧪 ,   ࠡ⠥
		; DOSBox: ,  ॡ १㧪 ('Reboot requested, quitting now.')  蠥 ࠡ
		; Win3.11 (VMWare):  ࠡ뢠 (ந室 ਩ 襭  ᮮ饭,  ਫ 訫 楫⭮ ⥬)
		; Win98 (VMWare):  ࠡ뢠 (ந室 ਩ 襭 ࠡ ணࠬ १ ᪮쪮 ᥪ㭤)
		; WinNT-7 (VMWare):  ࠡ뢠 (ணࠬ  蠥 ࠡ  뢮 ᮮ饭)
		int	19h		; १㧪
		ret
end if ; if used Reset5

if	RETURN
Return:		;---------------------------------------------------------------------------------------------------------------
		;  
  if	 PRINTSTATUS
		; ࠭塞 ⥪饥 祭 ⥪, 䫠, ॣ஢ ( 뢮 ଠ樨)  ⠭ ० ⥪, DS  ES
		mov	[cs:ValESP],esp
		mov	[cs:ValSS],ss
  else
		cli			;  直 砩,  䫠 IF   ⠪   = 0
  end if
		lss	sp,dword [cs:SavedSP]
  if	 PRINTSTATUS
		pushfd
		pop	[cs:EFLAGS]
		cli			;  直 砩,  䫠 IF   ⠪   = 0
		push	gs
		push	fs
		push	[cs:ValSS]
		push	es
		push	ds
		push	cs
  end if
		push	cs
		pop	ds		; DS = CS
  if	 PRINTSTATUS
		push	cs
		pop	es		; ES = CS
		push	[ValESP]
		push	ebp
		push	edi
		push	esi
		push	edx
		push	ecx
		push	ebx
		push	eax
		push	[SavedCR0]
		mov	eax,cr0
		push	eax
		push	[EFLAGS]
		mov	ah,[PA1]
		in	al,0A1h
		push	ax
		mov	ah,[P21]
		in	al,21h
		push	ax
		mov	ah,[P92]
		in	al,92h
		push	ax
		mov	ah,[P70]
		in	al,70h
		push	ax

		; 뢠 ࠭  ⥪ 祭  ப MsgVal (८ࠧ   ᫮ )
		;      ॣ dh, ..  ᯮ  楤 ValToStr!
		cld
		mov	si,ValLen	; ⨯   ᥫ
		mov	di,MsgVal	; ப
	@@:	mov	al,'='
		mov	ch,1
		repne scasb
		call	ValToStr	; ᫥ ᨬ '='    ப
		cmp	byte [si],0
		jne	@R
  end if ; if PRINTSTATUS

  if	RETURNMODE = 5
		; ⠭ ᪨ 뢠
		mov	al,[P21]
		out	21h,al		; 뢠 0..7
		mov	al,[PA1]
		out	0A1h,al		; 뢠 8..15
  end if
		; ⠭ ﭨ A20
		mov	al,[P92]
		and	al,not 1	;  直 砩 ᨬ  0, ⮡  ४   0  1   맢 
		out	92h,al

		mov	si,MsgOk
		jmp	Finish

  if	PRINTSTATUS
ValToStr:		; 뢮 祭  ப
                pop	bx		;  
		lodsb			; ⠥ ⨯/ ᫠
		test	al,al
		js	.bin		; 筮, ᫨ 訩  ⠭

		cmp	al,4		;   ࠤ ( 4 ⠬, hex-ࠬ)
		ja	@F		;  = 8 ?
		pop	dx		; , ⠥ 1 ᫮
		shl	edx,16		;  ᤢ  
		db	0B9h		; mov cx,? ( 䠪 - jmp $+3, .. ய ᫥饩 樨)
	@@:	pop	edx
		movzx	cx,al		; cx =  ( hex-)
	@@:	rol	edx,4		; ६頥  ࠤ  訥 4 
		mov	al,dl
		and	al,0Fh		; 뤥塞  
		cmp	al,10
		sbb	al,69h
		das			; ८ࠧ㥬  hex-
		stosb			; 뢮
		loop	@R		;  ᫥饩 
		jmp	bx		;  ret
		
	.bin:	mov	dl,dh		;  直 砩 ࠭  祭  dh
		test	al,1		; ᫨ 訩  ⠭,
		jnz	@F		; ...⠢塞 祭, ⮥  dh
		pop	dx		; ,  祭  ⥪
	@@:	mov	cx,8		; - 
	@@:	mov	al,'0'
		shl	dl,1		; 砥 訩 
		adc	al,0		; 塞   ah
		stosb			; 뢮
		loop	@R		;  ᫥饬 
		jmp	bx		;  ret
  end if ; PRINTSTATUS
end if ; if RETURN

;-----------------------------------------------------------------------------------------------------------------------
MsgFail		db	'CPU reset is failed!',13,10,0
if	RETURN
  MsgOk		db	'Successfully returned after CPU reset!',13,10
  if	PRINTSTATUS
		db	80h+38,'-',13,10
    MsgVal	db	'Port 0x70 (bin): new=00000000, old=00000000 (bit 7: NMI state, zero if enabled)',13,10
		db	'Port 0x92 (bin): new=00000000, old=00000000 (bit 1: A20 state; bit 0: INIT_NOW)',13,10
		db	'Port 0x21 (bin): new=00000000, old=00000000 (IRQ 0..7 masks)',13,10
		db	'Port 0xA1 (bin): new=00000000, old=00000000 (IRQ 8..15 masks)',13,10
		db	'Registers (hex): EFLAGS=00000000, CR0=00000000, old CR0=00000000',13,10
		db	80h+17,' EAX=00000000, EBX=00000000, ECX=00000000, EDX=00000000',13,10
		db	80h+17,' ESI=00000000, EDI=00000000, EBP=00000000, ESP=00000000',13,10
		db	80h+17,' CS=0000, DS=0000, ES=0000, SS=0000, FS=0000, GS=0000',13,10,0
    ValLen	db	80h,81h,80h,81h,80h,81h,80h,81h,8,8,8,8,8,8,8,8,8,8,8,4,4,4,4,4,4
  end if ; if PRINTSTATUS
  		db	0		;   MsgOk,  ValLen ( ᨬ  祭 PRINTSTATUS)
  SavedSP	rw	1
  SavedSS	rw	1
  P21		rb	1
  PA1		rb	1
  P92		rb	1
  if	PRINTSTATUS
    P70		rb	1
    SavedCR0	rd	1
    ValESP	rd	1
    ValSS	rw	1
    EFLAGS	rd	1
  end if
end if ; if RETURN
